# This Python file uses the following encoding: utf-8

from constants import *
from Media import *
from random import randint

# КЛАСС ИГРЫ
class Game:
    def __init__(self):   
        # размеры доски в клетках:
        self.cols = SIZE
        self.rows = SIZE
        # игровое поле:
        self.board = None
    
        # счёт игры:
        self.result = [0] * 3
    
        # число ходов:
        self.nMove = 0
        # игрок, делающий ход:
        self.player = PLAYER
        # победитель:
        self.winner = None
    
        # состояние игры:
        self.flgGameOver = True

    
    # НОВАЯ ИГРА              
    def newGame(self):
        # готовимся к новой игре -->
        # создаём пустое поле:
        self.board = self.createArray(self.rows, self.cols)
        # обнуляем число ходов:
        self.nMove = 0
    
        #print("Новая игра")
        #print('')
    
        # кто делает первый ход:
        self.player = randint(PLAYER, COMPUTER)
        self.flgGameOver = False

     
    # СОЗДАЁМ ДВУМЕРНЫЙ СПИСОК
    def createArray(self, cols, rows):
        # игровое поле:
        return [[IEMPTY for row in range(rows)] for col in range(cols)]
        

    # РИСУЕМ ИГРОВОЕ ПОЛЕ
    def drawBoard(self):
        for row in range(self.rows):
            for col in range(self.cols):
                item = self.board[col][row]
                x = 103 + 100 * col
                y = 203 + 100 * row
                if item == IEMPTY: pass
                elif item == IPLAYER: image(Media.imgX, x, y)
                elif item == ICOMPUTER: image(Media.imgO, x, y)
