# Крестики-нолики на доске 3 х 3 клетки

# добавляем библиотеки:
add_library('controlP5') # ЭУ
add_library('minim')     # звук


from constants import *
from colors import *
from Game import Game
from Media import *
from Timer import Timer
from random import randint


# ЗАГРУЖАЕМ МЕДИАФАЙЛЫ
def preload():                
    # загружаем картинки -->
    global imgBack 
    # загружаем фоновую картинку:
    imgBack = loadImage("data/imgBack.png")    
    Media.load(Minim(this))

    
# ГОТОВИМСЯ К ПЕРВОЙ ИГРЕ
def setup():                
    # создаём окно:
    size(WIDTH, HEIGHT)
    
    # загружаем файлы:
    preload()
    
    # координатные режимы:
    imageMode(CORNER)
    rectMode(CORNER)
    
    # создаём кнопки -->
    # создаём кнопку Новая игра:
    cp5 = ControlP5(this) 
    global btnNewGame 
    imgs = [loadImage("button_a.png"),loadImage("button_b.png"),\
            loadImage("button_c.png")]
    btnNewGame = cp5.addButton("Новая игра  ") \
    .setPosition(160, 555) \
    .setSize(180,33) \
    .setImages(imgs)
    
    # создаём цифровые кнопки 1..9:
    global button
    # загружаем прозрачную картинку:
    imgButton95x96 = loadImage("data/imgButton96x96.png")
    button = []
    for id in range(9+1):
        btn = cp5.addButton(str(id)) \
        .setSize(IMAGE_WIDTH, IMAGE_HEIGHT) \
        .setValue(id) \
        .setImage(imgButton95x96)
        button.append(btn)
    # устанавливаем цифровые кнопки: 
    x = y = 0
    dx = 100
    dy = 100
    xb = 103
    yb = 203   
    for id in range(9+1):
        if (id + 1 == 4 or id + 1 == 7):
            xb = 103
            yb += dy
        button[id].setPosition(x + xb, y + yb)
        xb += dx

    global timer
    timer = None   
                                   
    # создаём игру:
    global game
    game = Game()
    # начинаем игру:
    newGame()
    

# ИГРОВОЙ ЦИКЛ
def draw():                   
    # игра закончилась:
    if (game.flgGameOver):
        return
    
    # рисуем новый кадр:
    drawSzene()
    
    global timer
    if timer:
        timer.sleep()
    

# ОБНОВЛЯЕМ СЦЕНУ
def drawSzene():
    # рисуем фоновую картинку:
    background(imgBack)
    
    # рисуем доску:
    game.drawBoard()
    
    # пишем название игры:
    textSize(42)
    textAlign(LEFT)
    #textStyle(BOLD)
    strokeWeight(0)
    fill(138, 43, 226, 100)
    text(u"Крестики-нолики", 65, 50)
    
    # печатаем текущего игрока:
    textAlign(LEFT)
    textSize(30)
    fill(0, 255, 0, 100)
    strp = u'Ход '
    if (game.player == PLAYER):
        strp += u'Игрока'
    else:
        strp += u'Компьютера'
    text(strp, 100, 185)
    
    # счёт игры:
    textSize(40)
    textAlign(LEFT)
    fill(255, 0, 255, 100)
    strr = u"Счёт " + str(game.result[PLAYER]) + " : " + str(game.result[COMPUTER])
    text(strr, 100, 140)
    

# НАЖИМАЕМ КНОПКУ МЫШКИ
def mousePressed():  
    # если нажата кнопка...
    if btnNewGame.isMousePressed():
        newGame()  
    for b in button:
        if b.isMousePressed():  
            movePlayer(b)
            break
        
        
#  ХОД ИГРОКА
def movePlayer(btn):
    # игра закончилась:
    if (game.flgGameOver):
        return
    # ход Компьютера:
    if (game.player != PLAYER):
        return
    
    # звук нажатия на кнопку:
    Media.sndChose.trigger()
    
    # номер нажатой клетки 0..8:
    num = int(btn.getValue())
    # координаты на доске:
    row = num // game.rows
    col = num % game.cols
    
    # проверяем ход игрока -->
    # эта клетка уже занята?
    if (game.board[col][row] != IEMPTY):
        # ошибка:
        Media.sndError.trigger()
        return
    
    # ход сделан:
    game.nMove += 1
    # ставим крестик:
    game.board[col][row] = IPLAYER
    
    # проверяем, не закончилась ли игра: 
    isGameOver()
    # передаём ход Компьютеру:
    game.player = COMPUTER
    global timer
    timer = Timer(1000, moveComputer)
    #moveComputer()
    

# ВЫБИРАЕМ ХОД
def test00XX(player):
    # сумма двух значков заданного игрока:
    summa = player * 2
    
    # ищем ряд из двух значков игрока:
    sum = 0
    emptycell = 0
    
    # проверяем горизонтали:
    for y in range(game.rows):
        sum = 0
        for x in range(game.cols):
            if (game.board[x][y] == IEMPTY):
                emptycell = x
            sum += game.board[x][y]
    
        if (sum == summa):
            return { "x": emptycell, "y": y }
    
    # проверяем вертикали:
    for x in range(game.cols):
        sum = 0
        for y in range(game.rows):
            if (game.board[x][y] == IEMPTY):
                emptycell = y
            sum += game.board[x][y]
    
        if (sum == summa):
            return { "x": x, "y": emptycell }
    
    # проверяем диагонали -->
    # нисходящая:
    sum = 0
    for y in range(game.rows):
        if (game.board[y][y] == IEMPTY):
            emptycell = y
        sum += game.board[y][y]

    if (sum == summa):
        return { "x": emptycell, "y": emptycell }
    
    # восходящая:
    sum = 0
    for y in range(game.rows - 1, -1, -1):
        if (game.board[game.rows - y - 1][y] == IEMPTY):
            emptycell = y
        sum += game.board[game.rows - y - 1][y]

    if (sum == summa):
        return { "x": game.rows - emptycell - 1, "y": emptycell };
    
    # двух символов нет:
    return None


# ИЩЕМ КЛЕТКУ ДЛЯ ХОДА КОМПЬЮТЕРА
def getMoveCoords():
    #print(str(game.nMove))
    # координаты клетки:
    col = 0
    row = 0
    
    # если есть 2 нолика и пустая клетка
    # в каком-либо ряду,
    # то ставим нолик:
    res = test00XX(ICOMPUTER)
    if (res):
        return res
    
    # если есть 2 крестика и пустая клетка
    # в каком-либо ряду,
    # то ставим нолик:
    res = test00XX(IPLAYER)
    if (res):
        return res
    
    # список клеток для хода:
    cand = []
    # максимальное значение клеток:
    maxvalue = 0
    for y in range(game.rows):
        for x in range(game.cols):
            # проверяем только пустые клетки: 
            if (game.board[x][y] == IEMPTY):
                # если значение в клетке
                # больше максимального,
                # то запоминаем клетку:
                if (VALUE[x][y] > maxvalue):
                    maxvalue = VALUE[x][y]
                    cand = []
                # клетки с маленьким значением
                # пропускаем:
                elif (VALUE[x][y] < maxvalue):
                    continue
                # если такое значение клетки
                # уже было, то добавояем её в список:
                cand.append({ "coords": { "x": x, "y": y } })

    #print(VALUE)
    #print(cand)
    
    # выбираем случайную клетку из списка:
    id = randint(0, len(cand) - 1)
    cell = cand[id];
    col = cell["coords"]["x"]
    row = cell["coords"]["y"]
    return { "x": col, "y": row }


# ХОД КОМПЬЮТЕРА
def moveComputer():
    if (game.flgGameOver):
        return
    
    Media.sndChose.trigger()
    # ход выполнен:
    game.nMove += 1
    # выбираем клетку для хода:
    res = getMoveCoords()
    
    # ставим нолик:
    game.board[res["x"]][res["y"]] = ICOMPUTER
    
    # проверяем, не закончилась ли игра:
    isGameOver()
    # ход переходит к Игроку:
    game.player = PLAYER
    

# ПРОВЕРЯЕМ, НЕ ЗАКОНЧИЛАСЬ ЛИ ИГРА
def isGameOver():    
    # сумма трёх значков заданного игрока:
    summa = 0
    
    if (game.player == PLAYER):
        summa = IPLAYER * SIZE
    else:
        summa = ICOMPUTER * SIZE
    
    # ищем ряд из трёх значков игрока:
    sum = 0
    
    # проверяем горизонтали:
    for y in range(SIZE):
        sum = 0
        for x in range(SIZE):
            sum += game.board[x][y]
    
        if (sum == summa):
            return gameOver(game.player)

    # проверяем вертикали:
    for x in range(SIZE):
        sum = 0
        for y in range(SIZE):
            sum += game.board[x][y]
    
        if (sum == summa):
            return gameOver(game.player)
    
    # проверяем диагонали:
    sum = 0
    for y in range(SIZE):
        sum += game.board[y][y]
    
    if (sum == summa):
        return gameOver(game.player)
    
    sum = 0
    for y in range(SIZE - 1, -1, -1):
        sum += game.board[SIZE - y - 1][y]
    
    if (sum == summa):
        return gameOver(game.player)
    
    # ничья?
    if (game.nMove == game.cols * game.rows):
        return gameOver(DRAW)
  
  
# ИГРА ЗАКОНЧЕНА
def gameOver(res):
    #print(res)
    # ничья:
    s = u'НИЧЬЯ'
    
    if (res != DRAW):
        game.winner = res
    
        # изменяем счёт:
        game.result[game.winner] += 1
        s = u'ПОБЕДИЛ '
        if (game.winner == PLAYER):
            s += u'ИГРОК';
        else:
            s += u'КОМПЬЮТЕР';

    # обновляем сцену:
    drawSzene()
    # игра закончена:
    game.flgGameOver = True
    
    # рисуем табличку:
    strokeWeight(2);
    stroke(Black)
    fill(255, 0, 0, 160)
    rectMode(CENTER)
    rect(width / 2, -16 + 370, 440, 70)
    strokeWeight(0)
    rectMode(CORNER)
    # печатаем сообщение:
    fill(255, 255, 0)
    textAlign(CENTER)
    textSize(32)
    
    text(s, width / 2, 364)
    
    Media.sndWin.trigger()
    

# НАЖИМАЯЕМ КНОПКУ "НОВАЯ ИГРА"
def newGame():
    #print "newGame"
    game.newGame()
    if (game.player == COMPUTER):
        global timer
        timer = Timer(500, moveComputer)
        #moveComputer()
